/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// identities - Array of identities in sip uri format.    contactsSubscriptions - ContactsSubscriptions parameter block.
    /// </summary>
    [DataContract]
        public partial class ContactsSubscribeParams :  IEquatable<ContactsSubscribeParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ContactsSubscribeParams" /> class.
        /// </summary>
        /// <param name="identities">identities.</param>
        /// <param name="contactsSubscriptions">contactsSubscriptions.</param>
        public ContactsSubscribeParams(List<string> identities = default(List<string>), ContactsSubscriptions contactsSubscriptions = default(ContactsSubscriptions))
        {
            this.Identities = identities;
            this.ContactsSubscriptions = contactsSubscriptions;
        }
        
        /// <summary>
        /// Gets or Sets Identities
        /// </summary>
        [DataMember(Name="identities", EmitDefaultValue=false)]
        public List<string> Identities { get; set; }

        /// <summary>
        /// Gets or Sets ContactsSubscriptions
        /// </summary>
        [DataMember(Name="contactsSubscriptions", EmitDefaultValue=false)]
        public ContactsSubscriptions ContactsSubscriptions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ContactsSubscribeParams {\n");
            sb.Append("  Identities: ").Append(Identities).Append("\n");
            sb.Append("  ContactsSubscriptions: ").Append(ContactsSubscriptions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ContactsSubscribeParams);
        }

        /// <summary>
        /// Returns true if ContactsSubscribeParams instances are equal
        /// </summary>
        /// <param name="input">Instance of ContactsSubscribeParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ContactsSubscribeParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Identities == input.Identities ||
                    this.Identities != null &&
                    input.Identities != null &&
                    this.Identities.SequenceEqual(input.Identities)
                ) && 
                (
                    this.ContactsSubscriptions == input.ContactsSubscriptions ||
                    (this.ContactsSubscriptions != null &&
                    this.ContactsSubscriptions.Equals(input.ContactsSubscriptions))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Identities != null)
                    hashCode = hashCode * 59 + this.Identities.GetHashCode();
                if (this.ContactsSubscriptions != null)
                    hashCode = hashCode * 59 + this.ContactsSubscriptions.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
